Debian Bug report logs - #602959
btag: FTBFS with binutils-gold because of missing symbol 'boost::system::get_system_category()'

version graph

Package: btag; Maintainer for btag is Fernando Tarlá Cardoso Lemos <fernandotcl@gmail.com>; Source for btag is src:btag.

Reported by: Fabrice Coutadeur <fabricesp@ubuntu.com>

Date: Tue, 9 Nov 2010 19:09:02 UTC

Severity: serious

Tags: patch, sid, wheezy

Merged with 615699

Found in version btag/1.0.1-1

Fixed in version btag/1.1.0-1

Done: Fernando Tarlá Cardoso Lemos <fernandotcl@gmail.com>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Fernando Tarlá Cardoso Lemos <fernandotcl@gmail.com>:
Bug#602959; Package btag. (Tue, 09 Nov 2010 19:09:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Fabrice Coutadeur <fabricesp@ubuntu.com>:
New Bug report received and forwarded. Copy sent to Fernando Tarlá Cardoso Lemos <fernandotcl@gmail.com>. (Tue, 09 Nov 2010 19:09:05 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Fabrice Coutadeur <fabricesp@ubuntu.com>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: btag: FTBFS with binutils-gold because of missing symbol 'boost::system::get_system_category()'
Date: Tue, 09 Nov 2010 19:48:26 +0100
[Message part 1 (text/plain, inline)]
Package: btag
Version: 1.0.1-1
Severity: wishlist
Tags: patch
User: ubuntu-devel@lists.ubuntu.com
Usertags: origin-ubuntu natty ubuntu-patch

Hi,

btag FTBFS with binutils-gold. Here is the relevant part of the build log:
...
Linking CXX executable btag
/usr/bin/cmake -E cmake_link_script CMakeFiles/btag.dir/link.txt --verbose=1
/usr/bin/c++   -g -O2  -Wall -Werror  -Wl,-Bsymbolic-functions CMakeFiles/btag.dir/src/BasicStringFilter.cpp.o CMakeFiles/btag.dir/src/EnglishTitleLocalizationHandler.cpp.o CMakeFiles/btag.dir/src/InteractiveTagger.cpp.o CMakeFiles/btag.dir/src/main.cpp.o CMakeFiles/btag.dir/src/RenamingFilter.cpp.o CMakeFiles/btag.dir/src/SimpleCapitalizationFilter.cpp.o CMakeFiles/btag.dir/src/SpanishTitleLocalizationHandler.cpp.o CMakeFiles/btag.dir/src/StandardConsole.cpp.o CMakeFiles/btag.dir/src/TitleCapitalizationFilter.cpp.o CMakeFiles/btag.dir/src/TitleLocalizationHandler.cpp.o  -o btag -rdynamic -lboost_filesystem-mt -ltag 
/usr/bin/ld: CMakeFiles/btag.dir/src/InteractiveTagger.cpp.o: undefined reference to symbol 'boost::system::get_system_category()'
/usr/bin/ld: note: 'boost::system::get_system_category()' is defined in DSO /usr/lib/libboost_system.so.1.42.0 so try adding it to the linker command line
/usr/lib/libboost_system.so.1.42.0: could not read symbols: Invalid operation
collect2: ld returned 1 exit status
make[3]: *** [btag] Error 1


*** /tmp/tmpXqALRh
In Ubuntu, we've applied the attached patch to fix the FTBFS, by doing the 
following:

  *  debian/rules: added -lboost_system to LDFLAGS to force a fix link with
     libboost. This fixes a FTBFS with binutils-gold.

We thought you might be interested in doing the same. 


-- System Information:
Debian Release: squeeze/sid
  APT prefers maverick-updates
  APT policy: (500, 'maverick-updates'), (500, 'maverick-security'), (500, 'maverick-proposed'), (500, 'maverick')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.35-23-generic (SMP w/2 CPU cores)
Locale: LANG=es_ES.UTF-8, LC_CTYPE=es_ES.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash
[tmp9mUcuU (text/x-diff, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Fernando Tarlá Cardoso Lemos <fernandotcl@gmail.com>:
Bug#602959; Package btag. (Tue, 09 Nov 2010 23:39:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Fernando Lemos <fernandotcl@gmail.com>:
Extra info received and forwarded to list. Copy sent to Fernando Tarlá Cardoso Lemos <fernandotcl@gmail.com>. (Tue, 09 Nov 2010 23:39:03 GMT) Full text and rfc822 format available.

Message #10 received at 602959@bugs.debian.org (full text, mbox):

From: Fernando Lemos <fernandotcl@gmail.com>
To: Fabrice Coutadeur <fabricesp@ubuntu.com>, 602959@bugs.debian.org
Cc: pkg-boost-devel@lists.alioth.debian.org, Modestas Vainius <modax@debian.org>
Subject: Re: Bug#602959: btag: FTBFS with binutils-gold because of missing symbol 'boost::system::get_system_category()'
Date: Tue, 9 Nov 2010 21:37:43 -0200
Hi Fabrice,

2010/11/9 Fabrice Coutadeur <fabricesp@ubuntu.com>:
[...]
> In Ubuntu, we've applied the attached patch to fix the FTBFS, by doing the
> following:
>
>  *  debian/rules: added -lboost_system to LDFLAGS to force a fix link with
>     libboost. This fixes a FTBFS with binutils-gold.
>
> We thought you might be interested in doing the same.

I don't plan to do anything about this for the time being. The reason
for the FTBFS (as reported by others[2]) is that boost::filesystem
uses boost::system in its internal headers (in inline methods invoked
by the boost::filesystem::path constructor, for instance). A
boost::filesystem user is not supposed to know in advance that
boost::filesystem requires linkage against boost::system as this is an
implementation detail that could change in the future.

btag does not use boost::system at all, and therefore it would not
make any sense to think this is a problem btag must solve. I see a few
possibilities for this being solved the right way:

1. It might be possible to change booost::filesystem to make those
methods that rely on boost::system (I think it's just
boost::system::error_code) not inline anymore. This would work fine,
but it might not be viable as C++ templates must be inlined. I don't
see this happening, good luck convincing the Boost team that the way
gold works is the right way.

2. gold could revert to the traditional ld behavior. I don't see this
happening either.

3. CMake ships with a module to find the Boost modules, and that's
what btag uses. That module could be changed to include the system
module if the filesystem module is requested, but I'm not sure the
CMake devs would want that. If this is "fixed" in pkg-config, I guess
it could be "fixed" in CMake too.

4. If -Wl,--as-needed worked with gold, I could add it to the linker
flags. It doesn't seem to work, though:

/usr/bin/cmake -E cmake_link_script CMakeFiles/btag.dir/link.txt --verbose=1
/usr/bin/c++    -Wall -Werror -Wl,--as-needed
CMakeFiles/btag.dir/src/BasicStringFilter.cpp.o
CMakeFiles/btag.dir/src/EnglishTitleLocalizationHandler.cpp.o
CMakeFiles/btag.dir/src/InteractiveTagger.cpp.o
CMakeFiles/btag.dir/src/main.cpp.o
CMakeFiles/btag.dir/src/RenamingFilter.cpp.o
CMakeFiles/btag.dir/src/SimpleCapitalizationFilter.cpp.o
CMakeFiles/btag.dir/src/SpanishTitleLocalizationHandler.cpp.o
CMakeFiles/btag.dir/src/StandardConsole.cpp.o
CMakeFiles/btag.dir/src/TitleCapitalizationFilter.cpp.o
CMakeFiles/btag.dir/src/TitleLocalizationHandler.cpp.o  -o btag
-rdynamic -lboost_filesystem-mt -ltag
/usr/bin/ld: CMakeFiles/btag.dir/src/InteractiveTagger.cpp.o: in
function __static_initialization_and_destruction_0(int,
int):InteractiveTagger.cpp(.text+0x51d0): error: undefined reference
to 'boost::system::get_system_category()'
/usr/bin/ld: CMakeFiles/btag.dir/src/InteractiveTagger.cpp.o: in
function __static_initialization_and_destruction_0(int,
int):InteractiveTagger.cpp(.text+0x51dc): error: undefined reference
to 'boost::system::get_generic_category()'
/usr/bin/ld: CMakeFiles/btag.dir/src/InteractiveTagger.cpp.o: in
function __static_initialization_and_destruction_0(int,
int):InteractiveTagger.cpp(.text+0x51e8): error: undefined reference
to 'boost::system::get_generic_category()'
/usr/bin/ld: CMakeFiles/btag.dir/src/InteractiveTagger.cpp.o: in
function __static_initialization_and_destruction_0(int,
int):InteractiveTagger.cpp(.text+0x51f4): error: undefined reference
to 'boost::system::get_generic_category()'
/usr/bin/ld: CMakeFiles/btag.dir/src/InteractiveTagger.cpp.o: in
function __static_initialization_and_destruction_0(int,
int):InteractiveTagger.cpp(.text+0x5200): error: undefined reference
to 'boost::system::get_system_category()'
/usr/bin/ld: CMakeFiles/btag.dir/src/InteractiveTagger.cpp.o: in
function boost::system::error_code::error_code():InteractiveTagger.cpp(.text._ZN5boost6system10error_codeC1Ev+0x17):
error: undefined reference to 'boost::system::get_system_category()'
/usr/bin/ld: CMakeFiles/btag.dir/src/main.cpp.o: in function
__static_initialization_and_destruction_0(int,
int):main.cpp(.text+0xeb2): error: undefined reference to
'boost::system::get_system_category()'
/usr/bin/ld: CMakeFiles/btag.dir/src/main.cpp.o: in function
__static_initialization_and_destruction_0(int,
int):main.cpp(.text+0xebe): error: undefined reference to
'boost::system::get_generic_category()'
collect2: ld returned 1 exit status

That said, I don't want to create problems for derivatives. If the
benefits of having this patch in Debian outweigh the maintenance
burden of keeping track of whatever libraries the inlined methods of
boost::filesystem rely on, please let me know and I'll try to contact
my sponsor to get a "fixed" package uploaded.

By the way, I believe a better way to patch the build system would be
adding "system" to the list of modules required in CMakeLists.txt, as
well as adding libboost-system-dev to Build-Depends.

I'm CC'ing the CMake and Boost maintainers in case they have any suggestions.

[1]: http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=593876

Regards,




Information forwarded to debian-bugs-dist@lists.debian.org, Fernando Tarlá Cardoso Lemos <fernandotcl@gmail.com>:
Bug#602959; Package btag. (Wed, 10 Nov 2010 02:45:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Steve M. Robbins" <steve@sumost.ca>:
Extra info received and forwarded to list. Copy sent to Fernando Tarlá Cardoso Lemos <fernandotcl@gmail.com>. (Wed, 10 Nov 2010 02:45:03 GMT) Full text and rfc822 format available.

Message #15 received at 602959@bugs.debian.org (full text, mbox):

From: "Steve M. Robbins" <steve@sumost.ca>
To: Fernando Lemos <fernandotcl@gmail.com>
Cc: Fabrice Coutadeur <fabricesp@ubuntu.com>, 602959@bugs.debian.org, Modestas Vainius <modax@debian.org>, pkg-boost-devel@lists.alioth.debian.org
Subject: Re: [pkg-boost-devel] Bug#602959: btag: FTBFS with binutils-gold because of missing symbol 'boost::system::get_system_category()'
Date: Tue, 9 Nov 2010 20:41:23 -0600
[Message part 1 (text/plain, inline)]
Hello,

On Tue, Nov 09, 2010 at 09:37:43PM -0200, Fernando Lemos wrote:

> I don't plan to do anything about this for the time being. The reason
> for the FTBFS (as reported by others[2]) is that boost::filesystem
> uses boost::system in its internal headers (in inline methods invoked
> by the boost::filesystem::path constructor, for instance). A
> boost::filesystem user is not supposed to know in advance that
> boost::filesystem requires linkage against boost::system as this is an
> implementation detail that could change in the future.
> 
> btag does not use boost::system at all, and therefore it would not
> make any sense to think this is a problem btag must solve. I see a few
> possibilities for this being solved the right way:
> 
> 1. It might be possible to change booost::filesystem to make those
> methods that rely on boost::system (I think it's just
> boost::system::error_code) not inline anymore. This would work fine,
> but it might not be viable as C++ templates must be inlined. I don't
> see this happening, good luck convincing the Boost team that the way
> gold works is the right way.

Speaking only for myself: please do explain why gold is an
improvement.  It seems to be a regression to me and my suggestion
would be to avoid it and use the current linker.

I have no idea how one would properly handle dependencies in inlined
code, such as C++ templates.

Cheers,
-Steve
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Fernando Tarlá Cardoso Lemos <fernandotcl@gmail.com>:
Bug#602959; Package btag. (Wed, 10 Nov 2010 06:21:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Fabrice Coutadeur <coutadeurf@gmail.com>:
Extra info received and forwarded to list. Copy sent to Fernando Tarlá Cardoso Lemos <fernandotcl@gmail.com>. (Wed, 10 Nov 2010 06:21:03 GMT) Full text and rfc822 format available.

Message #20 received at 602959@bugs.debian.org (full text, mbox):

From: Fabrice Coutadeur <coutadeurf@gmail.com>
To: Fernando Lemos <fernandotcl@gmail.com>
Cc: 602959@bugs.debian.org, pkg-boost-devel@lists.alioth.debian.org, Modestas Vainius <modax@debian.org>
Subject: Re: Bug#602959: btag: FTBFS with binutils-gold because of missing symbol 'boost::system::get_system_category()'
Date: Wed, 10 Nov 2010 07:18:59 +0100
Hi Fernando,

and thanks for the quick answer!

2010/11/10, Fernando Lemos <fernandotcl@gmail.com>:
>>  *  debian/rules: added -lboost_system to LDFLAGS to force a fix link with
>>     libboost. This fixes a FTBFS with binutils-gold.
>
> I don't plan to do anything about this for the time being. The reason
> for the FTBFS (as reported by others[1]) is that boost::filesystem
> uses boost::system in its internal headers (in inline methods invoked
> by the boost::filesystem::path constructor, for instance). A

good point! I didn't checked boost bugs, as I thought it was a problem
in btag only.

> boost::filesystem user is not supposed to know in advance that
> boost::filesystem requires linkage against boost::system as this is an
> implementation detail that could change in the future.

Right

> 1. It might be possible to change booost::filesystem to make those
> methods that rely on boost::system (I think it's just
> boost::system::error_code) not inline anymore. This would work fine,
> but it might not be viable as C++ templates must be inlined. I don't
> see this happening, good luck convincing the Boost team that the way
> gold works is the right way.

From what I've understood, the mess with implicit linking, default
with previous versions of the linker, is that when the implicitly
linked library change, the application can break without knowing it,
and we (packagers) don't know that the application has to be linked
again. This is at least what we've been told in Ubuntu.
And it will be the same for Wheezy (see
http://wiki.debian.org/ToolChain/DSOLinking ): this error will become
RC and a fix has to be found (in boost or in btag).

> 3. CMake ships with a module to find the Boost modules, and that's
> what btag uses. That module could be changed to include the system
> module if the filesystem module is requested, but I'm not sure the
> CMake devs would want that. If this is "fixed" in pkg-config, I guess
> it could be "fixed" in CMake too.

In another package, I fixed the .pc file to add an implicit linked
library to the generated LDFLAGS.
Right now, I don't think this is fixed in using pkg-config, as, AFAIK,
no .pc files are delivered in the -dev packages of boost in Ubuntu
either. Until now, btag is the second package I find with this issue.

> That said, I don't want to create problems for derivatives. If the
> benefits of having this patch in Debian outweigh the maintenance
> burden of keeping track of whatever libraries the inlined methods of
> boost::filesystem rely on, please let me know and I'll try to contact
> my sponsor to get a "fixed" package uploaded.

I perfectly understand that the fix I applied in Ubuntu is not
perfect, and I think we can wait until the release of Squeeze to see
how to fix it in a clean manner: I'll merge the new packages that you
may upload in the meantime.

> By the way, I believe a better way to patch the build system would be
> adding "system" to the list of modules required in CMakeLists.txt, as
> well as adding libboost-system-dev to Build-Depends.

That's a nicer fix, yes. Anyway, I'll wait a bit to see what happen.

Thanks!

Fabrice




Information forwarded to debian-bugs-dist@lists.debian.org, Fernando Tarlá Cardoso Lemos <fernandotcl@gmail.com>:
Bug#602959; Package btag. (Thu, 11 Nov 2010 13:45:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Fernando Lemos <fernandotcl@gmail.com>:
Extra info received and forwarded to list. Copy sent to Fernando Tarlá Cardoso Lemos <fernandotcl@gmail.com>. (Thu, 11 Nov 2010 13:45:05 GMT) Full text and rfc822 format available.

Message #25 received at 602959@bugs.debian.org (full text, mbox):

From: Fernando Lemos <fernandotcl@gmail.com>
To: Fabrice Coutadeur <coutadeurf@gmail.com>
Cc: 602959@bugs.debian.org, pkg-boost-devel@lists.alioth.debian.org, Modestas Vainius <modax@debian.org>
Subject: Re: Bug#602959: btag: FTBFS with binutils-gold because of missing symbol 'boost::system::get_system_category()'
Date: Thu, 11 Nov 2010 11:43:21 -0200
Hello Steve, Fabrice

On Wed, Nov 10, 2010 at 12:41 AM, Steve M. Robbins <steve@sumost.ca> wrote:
> Speaking only for myself: please do explain why gold is an
> improvement.  It seems to be a regression to me and my suggestion
> would be to avoid it and use the current linker.

I fully agree. gold is faster not only because it's highly optimized,
but also because it "cheats" by skipping the costly DSO dependency
lookup.

On Wed, Nov 10, 2010 at 4:18 AM, Fabrice Coutadeur <coutadeurf@gmail.com> wrote:
> From what I've understood, the mess with implicit linking, default
> with previous versions of the linker, is that when the implicitly
> linked library change, the application can break without knowing it,
> and we (packagers) don't know that the application has to be linked
> again. This is at least what we've been told in Ubuntu.

This is true for most packages. It's not valid for packages that
include libraries that inline code that, when compiled, refer to
symbols from other libraries, such as boost::filesystem and probably
many others.

boost::asio, for example, inlines code that refer to symbols from
libpthread. So if you link a boost::asio project and don't explicitly
link to libpthread with gold, it'll fail to link. Now this is even
worse than the problem with boost::filesystem, because using gold
you're now supposed to add a system library (-lpthread) to the
project, so you're going to have to conditionally link to it if it's a
Linux system (not to mention other Unix-like systems which don't have
-lpthread).

That's why some packages will require the DSO dependency lookup.
Adding those dependencies ourselves (as maintainers) is not a scalable
way to deal with the issue and it's duplicating information already
specified in the DSO, leading to inconsistencies in the long term.

> And it will be the same for Wheezy (see
> http://wiki.debian.org/ToolChain/DSOLinking ): this error will become
> RC and a fix has to be found (in boost or in btag).

I haven't been subscribed at -devel for long enough, but I don't
recall a discussion about gold there (there was a MBF announcement in
2009, but nothing was said about making gold the default). I don't
think this is going to get through, not unless gold runs with
--add-needed enabled by default or at least has that option available
(it's not supported at the moment).

Thanks for reporting the issue Fabrice, but for the time being I plan
to leave things as they are and postpone further discussion for when
(and if) gold becomes the default linker.

Regards,




Information forwarded to debian-bugs-dist@lists.debian.org, Fernando Tarlá Cardoso Lemos <fernandotcl@gmail.com>:
Bug#602959; Package btag. (Sat, 08 Jan 2011 16:45:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ilya Barygin <barygin@gmail.com>:
Extra info received and forwarded to list. Copy sent to Fernando Tarlá Cardoso Lemos <fernandotcl@gmail.com>. (Sat, 08 Jan 2011 16:45:03 GMT) Full text and rfc822 format available.

Message #30 received at 602959@bugs.debian.org (full text, mbox):

From: Ilya Barygin <barygin@gmail.com>
To: 602959@bugs.debian.org
Subject: btag: FTBFS with binutils-gold because of missing symbol 'boost::system::get_system_category()'
Date: Sat, 8 Jan 2011 19:40:24 +0300
Hello,

This probably should be merged with #593876:

http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=593876

libboost-filesystem-dev: Undeclared indirect dependency of
boost_filesystem on boost_system causes link failure




Information forwarded to debian-bugs-dist@lists.debian.org, Fernando Tarlá Cardoso Lemos <fernandotcl@gmail.com>:
Bug#602959; Package btag. (Sat, 08 Jan 2011 17:12:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Fernando Lemos <fernandotcl@gmail.com>:
Extra info received and forwarded to list. Copy sent to Fernando Tarlá Cardoso Lemos <fernandotcl@gmail.com>. (Sat, 08 Jan 2011 17:12:03 GMT) Full text and rfc822 format available.

Message #35 received at 602959@bugs.debian.org (full text, mbox):

From: Fernando Lemos <fernandotcl@gmail.com>
To: Ilya Barygin <barygin@gmail.com>, 602959@bugs.debian.org
Subject: Re: Bug#602959: btag: FTBFS with binutils-gold because of missing symbol 'boost::system::get_system_category()'
Date: Sat, 8 Jan 2011 15:10:29 -0200
Hi,

2011/1/8 Ilya Barygin <barygin@gmail.com>:
> Hello,
>
> This probably should be merged with #593876:
>
> http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=593876
>
> libboost-filesystem-dev: Undeclared indirect dependency of
> boost_filesystem on boost_system causes link failure

It is the same bug, though I'm not entirely convinced it's a Boost
bug. It's a hairy issue, people have been relying on some behavior for
quite some time now and this behavior is about to change. What's clear
to me is that if we don't find a good solution for this, we'll have a
lot of packages to fix.

Roger Leigh proposed better pkg-config support for Boost[1] and even
submitted a patch upstream[2] that still requires integration with
bjam (Boost's build system) and is awaiting upstream approval. It
would be great if we could have this integrated in Debian even if
upstream rejects it, in my opinion. I'd change btag to use pkg-config
in that case and #602959 could finally be closed.

[1]: http://lists.debian.org/debian-devel/2010/12/msg00134.html
[2]: https://svn.boost.org/trac/boost/ticket/1094

I'm hoping that once Squeeze is out this issue will be discussed again
and we'll reach consensus.

Regards,




Severity set to 'important' from 'wishlist' Request was from Fernando Lemos <fernandotcl@gmail.com> to control@bugs.debian.org. (Mon, 28 Feb 2011 01:33:04 GMT) Full text and rfc822 format available.

Merged 602959 615699. Request was from Fernando Lemos <fernandotcl@gmail.com> to control@bugs.debian.org. (Mon, 28 Feb 2011 01:33:05 GMT) Full text and rfc822 format available.

Added tag(s) wheezy. Request was from Matthias Klose <doko@debian.org> to control@bugs.debian.org. (Mon, 28 Feb 2011 14:28:05 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Fernando Tarlá Cardoso Lemos <fernandotcl@gmail.com>:
Bug#602959; Package btag. (Fri, 11 Mar 2011 23:03:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Fernando Lemos <fernandotcl@gmail.com>:
Extra info received and forwarded to list. Copy sent to Fernando Tarlá Cardoso Lemos <fernandotcl@gmail.com>. (Fri, 11 Mar 2011 23:03:03 GMT) Full text and rfc822 format available.

Message #46 received at 602959@bugs.debian.org (full text, mbox):

From: Fernando Lemos <fernandotcl@gmail.com>
To: Debian development list <debian-devel@lists.debian.org>, 602959@bugs.debian.org
Subject: Re: linker related changes for wheezy
Date: Fri, 11 Mar 2011 20:00:41 -0300
Hi,

On Sun, Feb 27, 2011 at 3:45 PM, Fernando Lemos <fernandotcl@gmail.com> wrote:
> In situations like this, what can package maintainers do? Would adding
> -Wl,--copy-dt-needed-entries to the build script be acceptable and
> would gold support that flag too? Should the bugs be assigned to the
> libraries instead (Boost and others)? There's no way this can be
> considered a bug in the packages that use such libraries, it makes no
> sense.

As it turns out, -Wl,--copy-dt-needed-entries isn't supported by gold
(yay). The patch Roger Leigh posted to the Boost bugtracker seems to
have been ignored[1], but I'm glad that there's been some discussion
between Roger and the Boost maintainers[2]. Hopefully this will be
sorted out in the future.

I'm not sure what other Boost-based package maintainers are doing. I
suspect they're just working around the problem by linking to the
missing libraries. I do not plan to do this with btag (unless it's
required in the near future for whatever reason), though I've patched
upstream for convenience. If we get pkg-config support, I'll adapt
btag's build system upstream and the Debian package as well.

Regards,

[1]: https://svn.boost.org/trac/boost/ticket/1094
[2]: http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=248674




Severity set to 'serious' from 'important' Request was from Lucas Nussbaum <lucas@lucas-nussbaum.net> to control@bugs.debian.org. (Sun, 13 Mar 2011 17:28:28 GMT) Full text and rfc822 format available.

Reply sent to Fernando Tarlá Cardoso Lemos <fernandotcl@gmail.com>:
You have taken responsibility. (Mon, 20 Jun 2011 05:51:04 GMT) Full text and rfc822 format available.

Notification sent to Fabrice Coutadeur <fabricesp@ubuntu.com>:
Bug acknowledged by developer. (Mon, 20 Jun 2011 05:51:04 GMT) Full text and rfc822 format available.

Message #53 received at 602959-close@bugs.debian.org (full text, mbox):

From: Fernando Tarlá Cardoso Lemos <fernandotcl@gmail.com>
To: 602959-close@bugs.debian.org
Subject: Bug#602959: fixed in btag 1.1.0-1
Date: Mon, 20 Jun 2011 05:47:09 +0000
Source: btag
Source-Version: 1.1.0-1

We believe that the bug you reported is fixed in the latest version of
btag, which is due to be installed in the Debian FTP archive:

btag_1.1.0-1.debian.tar.gz
  to main/b/btag/btag_1.1.0-1.debian.tar.gz
btag_1.1.0-1.dsc
  to main/b/btag/btag_1.1.0-1.dsc
btag_1.1.0-1_amd64.deb
  to main/b/btag/btag_1.1.0-1_amd64.deb
btag_1.1.0.orig.tar.gz
  to main/b/btag/btag_1.1.0.orig.tar.gz



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 602959@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Fernando Tarlá Cardoso Lemos <fernandotcl@gmail.com> (supplier of updated btag package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Fri, 17 Jun 2011 20:50:31 -0300
Source: btag
Binary: btag
Architecture: source amd64
Version: 1.1.0-1
Distribution: unstable
Urgency: low
Maintainer: Fernando Tarlá Cardoso Lemos <fernandotcl@gmail.com>
Changed-By: Fernando Tarlá Cardoso Lemos <fernandotcl@gmail.com>
Description: 
 btag       - interactive command-line based multimedia tag editor
Closes: 602959
Changes: 
 btag (1.1.0-1) unstable; urgency=low
 .
   * New upstream release
   * Fixes FTBFS with the linker changes in wheezy (Closes: #602959)
   * Fixes FTBFS with libboost-filesystem >=1.46.0
   * Build-depend on libboost-dev (>=1.46.0), libboost-filesystem-dev (>=1.46.0)
   * Bump Standards-Version to 3.9.2 (no changes needed)
   * Bump debhelper compat to 8 (no changed needed)
   * Updated copyright file, switched to DEP-5
   * Updated watch file
Checksums-Sha1: 
 813ebb74526e8ed37845975966d5ba6f9065861e 1101 btag_1.1.0-1.dsc
 dc20eee4be65b98b23f26100b33e9c29f51defa9 15983 btag_1.1.0.orig.tar.gz
 c146a3a48986e3846b561461df0a363cdeb4002a 2357 btag_1.1.0-1.debian.tar.gz
 e931dde4924b185400462c5eece14507fae0ba8b 62412 btag_1.1.0-1_amd64.deb
Checksums-Sha256: 
 3182a2781ab80a994539d1b856d9e71803154c14a1432b294c2fb9dc7cfa5854 1101 btag_1.1.0-1.dsc
 b3d4bbf16eed10feab7de17595db596c2a42ada57e8eaf1905bdac3f2cee2b41 15983 btag_1.1.0.orig.tar.gz
 22470ab9985e17f83fade3aa3140489b2c069f8940b962f0383bbaee002cf700 2357 btag_1.1.0-1.debian.tar.gz
 224225dde5262dd9db5370fe972976bbc5240a82f413503920ce0f8599d16572 62412 btag_1.1.0-1_amd64.deb
Files: 
 14267e6b87e56d2b047cc934c03eacb5 1101 sound optional btag_1.1.0-1.dsc
 fbd7ca5276c284c5264b8f9c0de30f38 15983 sound optional btag_1.1.0.orig.tar.gz
 9af1ba79157029c8ef9bd061b3ba4d07 2357 sound optional btag_1.1.0-1.debian.tar.gz
 585e1e8b4f4f36a5b37ee8708a02bf50 62412 sound optional btag_1.1.0-1_amd64.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.11 (GNU/Linux)

iEYEARECAAYFAk3+2+sACgkQsbdbXzZcx6KhBQCgzWt1zuddElx7VBUOCYCyIKpD
0OkAniXVawrmg4iCd/BPv8y4v+lzurIF
=nWEd
-----END PGP SIGNATURE-----





Reply sent to Fernando Tarlá Cardoso Lemos <fernandotcl@gmail.com>:
You have taken responsibility. (Mon, 20 Jun 2011 05:51:04 GMT) Full text and rfc822 format available.

Notification sent to Matthias Klose <doko@debian.org>:
Bug acknowledged by developer. (Mon, 20 Jun 2011 05:51:05 GMT) Full text and rfc822 format available.

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Thu, 28 Jul 2011 07:35:55 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 06:13:00 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.